
/* anisort.c for anison.x */

#include "68anison.h"

#include <stdio.h>
#include <stdlib.h>


int Compare ( char *Former , char *Latter )
{
	/* Q̃f[^擪Kɔr */
	if ( ( Former == NULL ) || ( Latter == NULL ) ) return 1 ;

	while ( *(Former++) == *(Latter++) )
		if ( ( *Former == 0x00 ) || ( *Latter == 0x00 ) ) break ;

	if ( *(Former) == 0x00 ) return TRUE ;
	if ( *(Latter) == 0x00 ) return FALSE ;


	if ( *(Former-1) <= *(Latter-1) ) return TRUE ;

	return FALSE ;
}

int DeleteAniData ( struct ANISON *Mark )
{
	if ( Mark -> Last ) {
		( Mark -> Last ) -> Next = ( Mark -> Next ) ;
		}

	if ( Mark -> Next ) {
		( Mark -> Next ) -> Last = ( Mark -> Last ) ;
		}

	if ( Mark -> Last ) return FALSE ;

	return TRUE ;
}

struct ANISON *AddAniData ( struct ANISON *Chain , struct ANISON *NewData )
{
	struct ANISON *Top ;

	Top = Chain ;

	if ( Chain == NULL ) {
		NewData -> Last = NULL ;
		NewData -> Next = NULL ;
		Top = NewData ;
		}
	else {
		while ( Chain -> Next ) Chain = Chain -> Next ;
		Chain -> Next = NewData ;
		NewData -> Last = Chain ;
		NewData -> Next = NULL ;
		}

	return Top ;
}


struct ANISON *AniSort ( struct ANISON *Top , int Num )
{
	struct ANISON *NewTop = NULL , *Remarking , *Temp ;

	while ( Top )
		{
        /* ZNV\[g( */
		Remarking = Top ;
		for ( Temp = Top -> Next ; Temp ; Temp = Temp -> Next )
			{
			if ( ! Compare ( Remarking -> Data[Num] , Temp -> Data[Num] ) )
				Remarking = Temp ;
			}
		if ( DeleteAniData ( Remarking ) ) Top = Remarking -> Next ;
		NewTop = AddAniData ( NewTop , Remarking ) ;
		}

	return NewTop ;

}

int strfind ( char *Mother , char *Data )
{
	while ( *Mother )
		{
		char *m = Mother , *d = Data ;

		while ( *(m++) == *(d++) )
			{
			if ( *d == 0x00 ) return TRUE ;
			}

		Mother++ ;
		}

	return FALSE ;

}


struct ANISON *AniChainCat ( struct ANISON *Chain , struct ANISON *Leaf )
{
	/* Xgu */
	struct ANISON *Top = Chain ;

	if ( Chain == NULL ) return Leaf ;
	if ( Leaf  == NULL ) return Chain ;

	while ( Chain -> Next ) Chain = Chain -> Next ;
	Chain -> Next = Leaf ;

	while ( Leaf -> Last ) Leaf = Leaf -> Last ;
	Leaf -> Last = Chain ;

	return Top ;
}

struct ANISON *AniFind ( struct ANISON *Top , int Num , char *String )
{
	/* 擪̕Ƀqbgf[^W߂ */
	struct ANISON *NewTop = NULL , *Remarking ;

	for ( Remarking = Top ; Remarking ; )
		{
		struct ANISON *ReserveNext = Remarking -> Next ;

		if ( strfind ( Remarking -> Data[Num] , String ) ) {
			if ( DeleteAniData ( Remarking ) ) Top = Remarking -> Next ;
            NewTop = AddAniData ( NewTop , Remarking ) ;
			}

		Remarking = ReserveNext ;
		}

	return AniChainCat ( NewTop , Top ) ;
}
